Skip to content

Service List.

GET
/api/data/namespaces/system/site/{site}/api/v1/namespaces/{namespace}/services
curl --request GET \
--url https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/data/namespaces/system/site/example/api/v1/namespaces/example/services \
--header 'Authorization: <Authorization>'

API to GET list of services for a given namespace in a site.

Examples of this operation.

site
required
string

Site Site name.

namespace
required
string

Namespace Namespace to scope the listing of services in a site.

A successful response.

Media typeapplication/json

ServiceList holds a list of services.

object
items
List of services

Items in a collection or array

Array<object>

Service is a named abstraction of software service (for example, example-SQL) consisting of local port (for example 3306) that the proxy listens on, and the selector that determines which pods will answer requests sent through the proxy.

object
metadata
object
annotations
Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations +optional

Additional metadata and notes

object
clusterName
The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request. +optional

Cluster or grouping configuration

string
<= 1024 characters
creationTimestamp
object
nanos

Non-negative fractions of a second at nanosecond resolution. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be from 0 to 999,999,999 inclusive. This field may be limited in precision depending on context.

integer format: int32
seconds

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z inclusive.

string format: int64
<= 1024 characters
deletionGracePeriodSeconds
Number of seconds allowed for this object to gracefully terminate before it will be removed from the system. Only set when deletionTimestamp is also set. May only be shortened. Read-only. +optional

Security-related configuration

string format: int64
<= 1024 characters
deletionTimestamp
object
nanos

Non-negative fractions of a second at nanosecond resolution. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be from 0 to 999,999,999 inclusive. This field may be limited in precision depending on context.

integer format: int32
seconds

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z inclusive.

string format: int64
<= 1024 characters
finalizers
Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed. Finalizers may be processed and removed in any order. Order is NOT enforced because it introduces significant risk of stuck finalizers. finalizers is a shared field, any actor with permission can reorder it. If the finalizer list is processed in order, then this can lead to a situation in which the component responsible for the first finalizer in the list is waiting for a signal (field value, external system, or other) produced by a component responsible for a finalizer later in the list, resulting in a deadlock. Without enforced ordering finalizers are free to order amongst themselves and are not vulnerable to ordering changes in the list. +optional +patchStrategy=merge

Configuration parameter for finalizers

Array<string>
generateName

GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server.

If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header).

Applied only if Name is not specified. More info: HTTPS://git.K8s.I/O/community/contributors/devel/sig-architecture/api-conventions.md#idempotency +optional.

string
<= 1024 characters
generation
A sequence number representing a specific generation of the desired state. Populated by the system. Read-only. +optional

Configuration parameter for generation

string format: int64
<= 1024 characters
labels
Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels +optional

Key-value labels for organization and selection

object
managedFields

ManagedFields maps workflow-ID and version to the set of fields that are managed by that workflow. This is mostly for internal housekeeping, and users typically shouldn’t need to set or understand this field. A workflow can be the user’s name, a controller’s name, or the name of a specific apply path like “ci-cd”. The set of fields is always in the version that the workflow used when modifying the object.

+optional.

Array<object>

ManagedFieldsEntry is a workflow-ID, a FieldSet and the group version of the resource that the fieldset applies to.

object
apiVersion

APIVersion defines the version of this resource that this field set applies to. The format is “group/version” just like the top-level APIVersion field. It is necessary to track the version of a field set because it cannot be automatically converted.

string
<= 1024 characters
fieldsType
FieldsType is the discriminator for the different fields format and version. There is currently only one possible value: "FieldsV1"

Field specification or configuration

string
<= 1024 characters
fieldsV1
object
Raw

Raw is the underlying serialization of this object.

string format: byte
<= 1024 characters
manager

Manager is an identifier of the workflow managing these fields.

string
<= 1024 characters
operation

Operation is the type of operation which lead to this ManagedFieldsEntry being created. The only valid values for this field are ‘Apply’ and ‘Update’.

string
<= 1024 characters
time
object
nanos

Non-negative fractions of a second at nanosecond resolution. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be from 0 to 999,999,999 inclusive. This field may be limited in precision depending on context.

integer format: int32
seconds

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z inclusive.

string format: int64
<= 1024 characters
name
Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
namespace

Namespace defines the space within each name must be unique. An empty namespace is equivalent to the “default” namespace, but “default” is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty.

Must be a DNS_LABEL. Cannot be updated. More info: HTTP://Kubernetes.I/O/docs/user-guide/namespaces +optional.

string
>= 6 characters <= 1024 characters
ownerReferences
List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller. +optional +patchMergeKey=uid +patchStrategy=merge

Owner or responsible party

Array<object>

OwnerReference contains enough information to let you identify an owning object. An owning object must be in the same namespace as the dependent, or be cluster-scoped, so there is no namespace field.

object
apiVersion

API version of the referent.

string
<= 1024 characters
blockOwnerDeletion
If true, AND if the owner has the "foregroundDeletion" finalizer, then the owner cannot be deleted from the key-value store until this reference is removed. Defaults to false. To set this field, a user needs "delete" permission of the owner, otherwise 422 (Unprocessable Entity) will be returned. +optional

Blocking or denial configuration

boolean format: boolean
controller
If true, this reference points to the managing controller. +optional

Configuration parameter for controller

boolean format: boolean
kind
Kind of the referent. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

Resource type or kind

string
>= 12 characters <= 1024 characters
name
Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
uid
UID of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#uids

Unique identifier for this resource

string format: uuid
>= 36 characters <= 1024 characters
resourceVersion

An opaque value that represents the internal version of this object that can be used by clients to determine when objects have changed. May be used for optimistic concurrency, change detection, and the watch operation on a resource or set of resources. Clients must treat these values as opaque and passed unmodified back to the server. They may only be valid for a particular resource or set of resources.

Populated by the system. Read-only. Value must be treated as opaque by clients and . More info: HTTPS://git.K8s.I/O/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency +optional.

string
0 <= 1024 characters
selfLink

SelfLink is a URL representing this object. Populated by the system. Read-only.

DEPRECATED Kubernetes will stop propagating this field in 1.20 release and the field is planned to be removed in 1.21 release. +optional.

string
0 <= 1024 characters
uid

UID is the unique in time and space value for this object. It is typically generated by the server on successful creation of a resource and is not allowed to change on PUT operations.

Populated by the system. Read-only. More info: HTTP://Kubernetes.I/O/docs/user-guide/identifiers#uids +optional.

string format: uuid
>= 36 characters <= 1024 characters
spec
object
clusterIP
clusterIP is the IP address of the service and is usually assigned randomly by the master. If an address is specified manually and is not in use by others, it will be allocated to the service; otherwise, creation of the service will fail. This field can not be changed through updates. Valid values are "None", empty string (""), or a valid IP address. "None" can be specified for headless services when proxying is not required. Only applies to types ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies +optional

Cluster or grouping configuration

string
<= 1024 characters
externalIPs
externalIPs is a list of IP addresses for which nodes in the cluster will also accept traffic for this service. These IPs are not managed by Kubernetes. The user is responsible for ensuring that traffic arrives at a node with this IP. A common example is external load-balancers that are not part of the Kubernetes system. +optional

Configuration parameter for externalIPs

Array<string>
externalName
externalName is the external reference that kubedns or equivalent will return as a CNAME record for this service. No proxying will be involved. Must be a valid RFC-1123 hostname (https://tools.ietf.org/html/rfc1123) and requires Type to be ExternalName. +optional

Human-readable name for this resource

string
<= 1024 characters
externalTrafficPolicy
externalTrafficPolicy denotes if this Service desires to route external traffic to node-local or cluster-wide endpoints. "Local" preserves the client source IP and avoids a second hop for LoadBalancer and Nodeport type services, but risks potentially imbalanced traffic spreading. "Cluster" obscures the client source IP and may cause a second hop to another node, but should have good overall load-spreading. +optional

Configuration parameter for externalTrafficPolicy

string
<= 1024 characters
healthCheckNodePort
healthCheckNodePort specifies the healthcheck nodePort for the service. If not specified, HealthCheckNodePort is created by the service api backend with the allocated nodePort. Will use user-specified nodePort value if specified by the client. Only effects when Type is set to LoadBalancer and ExternalTrafficPolicy is set to Local. +optional

Network port number

integer format: int32
ipFamily
ipFamily specifies whether this Service has a preference for a particular IP family (e.g. IPv4 vs. IPv6). If a specific IP family is requested, the clusterIP field will be allocated from that family, if it is available in the cluster. If no IP family is requested, the cluster's primary IP family will be used. Other IP fields (loadBalancerIP, loadBalancerSourceRanges, externalIPs) and controllers which allocate external load-balancers should use the same IP family. Endpoints for this Service will be of this family. This field is immutable after creation. Assigning a ServiceIPFamily not available in the cluster (e.g. IPv6 in IPv4 only cluster) is an error condition and will fail during clusterIP assignment. +optional

IP address configuration

string
<= 1024 characters
loadBalancerIP
Only applies to Service Type: LoadBalancer LoadBalancer will get created with the IP specified in this field. This feature depends on whether the underlying cloud-provider supports specifying the loadBalancerIP when a load balancer is created. This field will be ignored if the cloud-provider does not support the feature. +optional

Configuration parameter for loadBalancerIP

string
<= 1024 characters
loadBalancerSourceRanges
If specified and supported by the platform, this will restrict traffic through the cloud-provider load-balancer will be restricted to the specified client IPs. This field will be ignored if the cloud-provider does not support the feature." More info: https://kubernetes.io/docs/tasks/access-application-cluster/configure-cloud-provider-firewall/ +optional

Range or scope specification

Array<string>
ports
The list of ports that are exposed by this service. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies +patchMergeKey=port +patchStrategy=merge +listType=map +listMapKey=port +listMapKey=protocol

Network port number

Array<object>

ServicePort contains information on service’s port.

object
name
The name of this port within the service. This must be a DNS_LABEL. All ports within a ServiceSpec must have unique names. When considering the endpoints for a Service, this must match the 'name' field in the EndpointPort. Optional if only one ServicePort is defined on this service. +optional

Human-readable name for the resource

string
>= 6 characters <= 1024 characters
nodePort
The port on each node on which this service is exposed when type=NodePort or LoadBalancer. Usually assigned by the system. If specified, it will be allocated to the service if unused or else creation of the service will fail. Default is to auto-allocate a port if the ServiceType of this Service requires one. More info: https://kubernetes.io/docs/concepts/services-networking/service/#type-nodeport +optional

Network port number

integer format: int32
port

The port that will be exposed by this service.

integer format: int32
>= 1 <= 65535
protocol
The IP protocol for this port. Supports "TCP", "UDP", and "SCTP". Default is TCP. +optional

Configuration parameter for protocol

string
<= 1024 characters
targetPort
object
intVal

Configuration parameter for intVal

integer format: int32
strVal

Configuration parameter for strVal

string
<= 1024 characters
type

Type or category classification

string format: int64
<= 1024 characters
publishNotReadyAddresses
publishNotReadyAddresses, when set to true, indicates that DNS implementations must publish the notReadyAddresses of subsets for the Endpoints associated with the Service. The default value is false. The primary use case for setting this field is to use a StatefulSet's Headless Service to propagate SRV records for its Pods without respect to their readiness for purpose of peer discovery. +optional

Network address or location

boolean format: boolean
selector
Route service traffic to pods with label keys and values matching this selector. If empty or not present, the service is assumed to have an external process managing its endpoints, which Kubernetes will not modify. Only applies to types ClusterIP, NodePort, and LoadBalancer. Ignored if type is ExternalName. More info: https://kubernetes.io/docs/concepts/services-networking/service/ +optional

Configuration parameter for selector

object
sessionAffinity
Supports "ClientIP" and "None". Used to maintain session affinity. Enable client IP based session affinity. Must be ClientIP or None. Defaults to None. More info: https://kubernetes.io/docs/concepts/services-networking/service/#virtual-ips-and-service-proxies +optional

Configuration parameter for sessionAffinity

string
<= 1024 characters
sessionAffinityConfig
object
clientIP
object
timeoutSeconds
timeoutSeconds specifies the seconds of ClientIP type session sticky time. The value must be >0 && <=86400(for 1 day) if ServiceAffinity == "ClientIP". Default value is 10800(for 3 hours). +optional

Security-related configuration

integer format: int32
topologyKeys
topologyKeys is a preference-order list of topology keys which implementations of services should use to preferentially sort endpoints when accessing this Service, it can not be used at the same time as externalTrafficPolicy=Local. Topology keys must be valid label keys and at most 16 keys may be specified. Endpoints are chosen based on the first topology key with available backends. If this field is specified and all entries have no backends that match the topology of the client, the service has no backends for that client and connections should fail. The special value "*" may be used to mean "any topology". This catch-all value, if used, only makes sense as the last value in the list. If this is not specified or empty, no topology constraints will be applied. +optional

Configuration parameter for topologyKeys

Array<string>
type
type determines how the Service is exposed. Defaults to ClusterIP. Valid options are ExternalName, ClusterIP, NodePort, and LoadBalancer. "ExternalName" maps to the specified externalName. "ClusterIP" allocates a cluster-internal IP address for load-balancing to endpoints. Endpoints are determined by the selector or if that is not specified, by manual construction of an Endpoints object. If clusterIP is "None", no virtual IP is allocated and the endpoints are published as a set of endpoints rather than a stable IP. "NodePort" builds on ClusterIP and allocates a port on every node which routes to the clusterIP. "LoadBalancer" builds on NodePort and creates an external load-balancer (if supported in the current cloud) which routes to the clusterIP. More info: https://kubernetes.io/docs/concepts/services-networking/service/#publishing-services-service-types +optional

Type or category classification

string
<= 1024 characters
status
object
loadBalancer
object
ingress
Ingress is a list containing ingress points for the load-balancer. Traffic intended for the service should be sent to these ingress points. +optional

Configuration parameter for ingress

Array<object>

LoadBalancerIngress represents the status of a load-balancer ingress point: traffic intended for the service should be sent to an ingress point.

object
hostname
Hostname is set for load-balancer ingress points that are DNS based (typically AWS load-balancers) +optional

Human-readable name for the resource

string
<= 1024 characters
ip
IP is set for load-balancer ingress points that are IP based (typically GCE or OpenStack load-balancers) +optional

IPv4 address in dotted decimal notation (e.g., 192.0.2.1)

string
<= 1024 characters
metadata
object
continue

Continue may be set if the user set a limit on the number of items returned, and indicates that the server has more data available. The value is opaque and may be used to issue another request to the endpoint that served this list to retrieve the next set of available objects. Continuing a consistent list may not be possible if the server configuration has changed or more than a few minutes have passed. The resourceVersion field returned when using this continue value will be identical to the value in the first response, unless you have received this token from an error message.

string
0 <= 1024 characters
remainingItemCount
remainingItemCount is the number of subsequent items in the list which are not included in this list response. If the list request contained label or field selectors, then the number of remaining items is unknown and the field will be left unset and omitted during serialization. If the list is complete (either because it is not chunking or because this is the last chunk), then there are no more remaining items and this field will be left unset and omitted during serialization. Servers older than v1.15 do not set this field. The intended use of the remainingItemCount is *estimating* the size of a collection. Clients should not rely on the remainingItemCount to be set or to be exact. +optional

Number of items or occurrences

string format: int64
<= 1024 characters
resourceVersion
String that identifies the server's internal version of this object that can be used by clients to determine when objects have changed. Value must be treated as opaque by clients and passed unmodified back to the server. Populated by the system. Read-only. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency +optional

Version number or identifier

string
0 <= 1024 characters
selfLink

SelfLink is a URL representing this object. Populated by the system. Read-only.

DEPRECATED Kubernetes will stop propagating this field in 1.20 release and the field is planned to be removed in 1.21 release. +optional.

string
0 <= 1024 characters
Examplegenerated
{
"items": [
{
"metadata": {
"annotations": {},
"clusterName": "example",
"creationTimestamp": {
"nanos": 1,
"seconds": "example"
},
"deletionGracePeriodSeconds": "example",
"deletionTimestamp": {
"nanos": 1,
"seconds": "example"
},
"finalizers": [
"example"
],
"generateName": "example",
"generation": "example",
"labels": {},
"managedFields": [
{
"apiVersion": "example",
"fieldsType": "example",
"fieldsV1": {
"Raw": "example"
},
"manager": "example",
"operation": "example",
"time": {
"nanos": 1,
"seconds": "example"
}
}
],
"name": "example",
"namespace": "example",
"ownerReferences": [
{
"apiVersion": "example",
"blockOwnerDeletion": true,
"controller": true,
"kind": "example",
"name": "example",
"uid": "2489E9AD-2EE2-8E00-8EC9-32D5F69181C0"
}
],
"resourceVersion": "example",
"selfLink": "example",
"uid": "2489E9AD-2EE2-8E00-8EC9-32D5F69181C0"
},
"spec": {
"clusterIP": "example",
"externalIPs": [
"example"
],
"externalName": "example",
"externalTrafficPolicy": "example",
"healthCheckNodePort": 1,
"ipFamily": "example",
"loadBalancerIP": "example",
"loadBalancerSourceRanges": [
"example"
],
"ports": [
{
"name": "example",
"nodePort": 1,
"port": 1,
"protocol": "example",
"targetPort": {
"intVal": 1,
"strVal": "example",
"type": "example"
}
}
],
"publishNotReadyAddresses": true,
"selector": {},
"sessionAffinity": "example",
"sessionAffinityConfig": {
"clientIP": {
"timeoutSeconds": 1
}
},
"topologyKeys": [
"example"
],
"type": "example"
},
"status": {
"loadBalancer": {
"ingress": [
{
"hostname": "example",
"ip": "example"
}
]
}
}
}
],
"metadata": {
"continue": "example",
"remainingItemCount": "example",
"resourceVersion": "example",
"selfLink": "example"
}
}

Returned when operation is not authorized.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when there is no permission to access resource.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when resource is not found.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation on resource is conflicting with current value.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation has been rejected as it is happening too frequently.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server encountered an error in processing API.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when service is unavailable temporarily.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server timed out processing request.

Media typeapplication/json
string format: string
Examplegenerated
example